Subject: Regression: v4.20-rc4: "SMSC LAN8710/LAN8720: Master/Slave resolution failed"

From: jacopo mondi <[email-masked]>
Date: Thu, 29 Nov 2018 15:42:06 +0100

Hello,
   netdev people,
   i.MX6 people,

   I'm running an i.MX6Q system, and since v4.20-rc1 the ethernet PHY
fails to properly startup, preventing me from mounting my NFS rootfs
(the interfaces gets configured after some minutes, but it's too late
for NFS).

The complete boot log:

[    3.000186] SMSC LAN8710/LAN8720 2188000.ethernet-1:00: attached PHY driver [SMSC LAN8710/LAN8720] (mii_bus:phy_addr=2188000.ethernet-1:00, irq=POLL)
[    3.015616] IPv6: ADDRCONF(NETDEV_UP): eth0: link is not ready
[    4.090582] SMSC LAN8710/LAN8720 2188000.ethernet-1:00: Master/Slave resolution failed, maybe conflicting manual settings?
[   13.038779] Waiting up to 110 more seconds for network.
[   23.058776] Waiting up to 100 more seconds for network.
[   33.078782] Waiting up to 90 more seconds for network.
[   43.098780] Waiting up to 80 more seconds for network.
[   53.118780] Waiting up to 70 more seconds for network.
[   63.138733] Waiting up to 60 more seconds for network.
[   73.158781] Waiting up to 50 more seconds for network.
[   83.178779] Waiting up to 40 more seconds for network.
[   93.198778] Waiting up to 30 more seconds for network.
[  103.218780] Waiting up to 20 more seconds for network.
[  113.238779] Waiting up to 10 more seconds for network.
[  123.048862] IP-Config: Guessing netmask 255.255.255.0
[  123.053967] IP-Config: Complete:
[  123.057247]      device=eth0, hwaddr=9c:53:cd:02:fb:34, ipaddr=192.168.1.100, mask=255.255.255.0, gw=255.255.255.255
[  123.067927]      host=192.168.1.100, domain=, nis-domain=(none)
[  123.074027]      bootserver=255.255.255.255, rootserver=192.168.1.64, rootpath=
[  123.082826] cfg80211: Loading compiled-in X.509 certificates for regulatory database
[  123.096250] cfg80211: Loaded X.509 cert 'sforshee: 00b28ddf47aef9cea7'
[  123.103753] ALSA device list:
[  123.106824]   No soundcards found.
[  123.111007] platform regulatory.0: Direct firmware load for regulatory.db failed with error -2
[  123.119879] cfg80211: failed to load regulatory.db

The board I'm using went in in v4.20-rc1:
https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=37c045d25e90038682b845de0a1db43c8301694d
https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=09ad741b7ecee8f7fa80bfa21eb0716394aff418

But with the above patches applied on v4.19 (on which I initially wrote them)
it still works with no issues.

Not a network expert and I might have missed some adjustments required
to have the PHY work properly on v4.20 (I see the issue on both v4.20-rc1
and v4.20-rc4 as well).

Before diving into a painful bisect, I'm here reporting the issue.

Thanks
   j